SPSBenchmark
=====

Benchmark tool for the Software Performance and Scalability course.

Configuration
-----

Edit: spsBenchmark.app.src

Parameters:
  - domain: The url without the resource.
  - pagefile: file with all the resources (one per line).
  - nPages: how many resource to use (the shuffling may take some time).

Then

    $ make config

Build
-----

    $ make

Documentation
-----

    $ make doc

Usage
-----
Start the console

    $ erl -pa ebin

Initiliaze the benchmarker

    > benchmarker:init().

Service time

    > benchmarker:startServiceTime(Duration, Warmup).

Open loop test

    > benchmarker:startOpenLoop(Rate, Duration, Warmup).

Closed loop test

    > benchmarker:startClosedLoop(Rate, Population, Duration, Warmup).
